## avogadro 1.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9)
project(Avogadro) # the name of your project

# The Avogadro version number, currently used by the Avogadro library too
set(Avogadro_VERSION_MAJOR 1)
set(Avogadro_VERSION_MINOR 1)
set(Avogadro_VERSION_PATCH 1)
set(Avogadro_VERSION "${Avogadro_VERSION_MAJOR}.${Avogadro_VERSION_MINOR}")
set(Avogadro_VERSION_FULL "${Avogadro_VERSION}.${Avogadro_VERSION_PATCH}")

set(CMAKE_MODULE_PATH ${Avogadro_SOURCE_DIR}/cmake/modules)

cmake_policy(SET CMP0003 NEW)

# this is adapted from KDE's FindKDE4Internal.cmake : default the build type to
# "release with debug info".
#
# We will define two other build types: Debug and Release.
# These names are case-insensitive i.e. you can do -DCMAKE_BUILD_TYPE=debug
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()
message(STATUS "The build type is ${CMAKE_BUILD_TYPE}")

include(CheckCXXCompilerFlag)
include(MacroEnsureVersion)
include(TestIfWeNeedFPermissive)

# use mulithreaded dll runtime on windows when using MSVC
if (MSVC)
  # Make sure the build is parallelised for faster builds
  set(CMAKE_CXX_FLAGS"${CMAKE_CXX_FLAGS} /MP")
  # Do not generate manifests for the plugins - caused issues loading plugins
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /MANIFEST:NO")
endif()

###########################################################
# Here I am adding GCC magic from KDE. With these settings#
# compiler issues are fixed and more warnings are issued. #
###########################################################
# We should always respect the users CXXFLAGS if they have set them
if (CMAKE_COMPILER_IS_GNUCXX)
  set (CMAKE_CXX_FLAGS_WARN "-Wnon-virtual-dtor -Wno-long-long -ansi -Wcast-align -Wchar-subscripts -Wall -Wextra -Wpointer-arith -Wformat-security -fno-check-new -fno-common -pedantic")
  # On Linux with GCC 4.3+ these flags generate thousands of warnings, so they
  # are now optional. Most of the warnings are in included headers.
  option(EXTRA_WARNINGS
    "Enable extra GCC warnings - can generate thousands" OFF)
  if(EXTRA_WARNINGS)
    # Enable extra compiler warnings for extra checking
    set (CMAKE_CXX_FLAGS_WARN "${CMAKE_CXX_FLAGS_WARN} -Wconversion -Woverloaded-virtual -Wfloat-equal")
#  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wshadow -Wold-style-cast")
  endif()
  add_definitions (-D_BSD_SOURCE)
  # Set some linker flags
  if(CMAKE_SYSTEM_NAME MATCHES Linux)
    set(CMAKE_SHARED_LINKER_FLAGS
      "-Wl,--fatal-warnings -Wl,--no-undefined -lc ${CMAKE_SHARED_LINKER_FLAGS}")
    set(CMAKE_SHARED_LINKER_FLAGS
      "-Wl,--enable-new-dtags ${CMAKE_SHARED_LINKER_FLAGS}")
    set(CMAKE_MODULE_LINKER_FLAGS
      "-Wl,--fatal-warnings -Wl,--no-undefined -lc ${CMAKE_SHARED_LINKER_FLAGS}")
    set(CMAKE_MODULE_LINKER_FLAGS
      "-Wl,--enable-new-dtags ${CMAKE_SHARED_LINKER_FLAGS}")
    set (CMAKE_EXE_LINKER_FLAGS
      "-Wl,--fatal-warnings -Wl,--no-undefined -lc ${CMAKE_SHARED_LINKER_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS
      "-Wl,--enable-new-dtags ${CMAKE_EXE_LINKER_FLAGS}")
  endif()
  # Now check if we can use visibility to selectively export symbols
  # Get the GCC version - from KDE4 cmake files
  exec_program(${CMAKE_C_COMPILER} ARGS --version OUTPUT_VARIABLE	_gcc_version_info)
  string (REGEX MATCH "[345]\\.[0-9]\\.[0-9]" _gcc_version "${_gcc_version_info}")
  # gcc on mac just reports: "gcc (GCC) 3.3 20030304 ..." without the
  # patch level, handle this here:
  if (NOT _gcc_version)
    string (REGEX REPLACE ".*\\(GCC\\).* ([34]\\.[0-9]) .*" "\\1.0" _gcc_version "${_gcc_version_info}")
  endif ()

  # No RTTI flag
  check_cxx_compiler_flag(-fno-rtti HAVE_NO_RTTI)
  if(HAVE_NO_RTTI)
    set(NO_RTTI_FLAG "-fno-rtti")
    # RTTI flag
    check_cxx_compiler_flag(-frtti HAVE_RTTI)
    if(HAVE_RTTI)
      set(RTTI_FLAG "-frtti")
    else()
      set(RTTI_FLAG "")
    endif()
  else()
    set(NO_RTTI_FLAG "")
    set(RTTI_FLAG "")
  endif()

  if(NOT APPLE) # Mac GCC42 compiler has bug
    check_cxx_compiler_flag(-fvisibility=hidden HAVE_GCC_VISIBILITY)
    set(HAVE_GCC_VISIBILITY ${HAVE_GCC_VISIBILITY} CACHE BOOL "GCC support for hidden visibility")
    macro_ensure_version("4.1.0" "${_gcc_version}" GCC_IS_NEWER_THAN_4_1)
    macro_ensure_version("4.2.0" "${_gcc_version}" GCC_IS_NEWER_THAN_4_2)
    set(_GCC_COMPILED_WITH_BAD_ALLOCATOR FALSE)
    if (GCC_IS_NEWER_THAN_4_1)
      exec_program(${CMAKE_C_COMPILER} ARGS -v OUTPUT_VARIABLE _gcc_alloc_info)
      string(REGEX MATCH "(--enable-libstdcxx-allocator=mt)" _GCC_COMPILED_WITH_BAD_ALLOCATOR "${_gcc_alloc_info}")
    endif ()

    if (HAVE_GCC_VISIBILITY AND GCC_IS_NEWER_THAN_4_1 AND NOT _GCC_COMPILED_WITH_BAD_ALLOCATOR)
      # We have all the parts necessary - use visibility support
      add_definitions(-DHAVE_GCC_VISIBILITY)
      set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
      if (GCC_IS_NEWER_THAN_4_2)
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
      endif()
    endif()
  endif()
  # Set up additional build flags for particular build types. These will be added to CMAKE_CXX_FLAGS,
  # they will not replace them.
  set(CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG -DQT_NO_DEBUG_OUTPUT -Wl,-s")
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO
    "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} ${CMAKE_CXX_FLAGS_WARN}")
  set(CMAKE_CXX_FLAGS_DEBUG   "-g3 -fno-inline ${CMAKE_CXX_FLAGS_WARN}")

  TEST_IF_WE_NEED_FPERMISSIVE(NEED_FPERMISSIVE)
  if(NEED_FPERMISSIVE)
    #OK, adding -fpermissive to the C++ compiler flags
    #Workaround for a problem with Boost.Python and GCC >= 4.3.1
    #Further information: cmake/modules/TestIfWeNeedFPermissive.cmake
    set (CMAKE_CXX_FLAGS   "${CMAKE_CXX_FLAGS} -fpermissive")
  endif()

  # define WITH_SSE2 to enable the SSE2 instruction set.
  # Available on Pentium 4, Athlon 64, and newer CPUs.
  # Enabled by default on the x86_64 architecture, but not on the x86 architecture.
  # If SSE2 is enabled, Eigen uses it by default; this can be disabled by
  # definining EIGEN_DONT_VECTORIZE.
  if(WITH_SSE2)
    message(STATUS "Enabling the SSE2 instruction set")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
  endif()
endif()


# Intel C++ Compiler
# Note: Windows version uses different options!
if(${CMAKE_CXX_COMPILER_ID} MATCHES Intel AND UNIX)
  # Disable warnings:
  # 981 - operands are evaluated in unspecified order
  # 1599 - foreach
  set (CMAKE_CXX_FLAGS_WARN "-Wnon-virtual-dtor -ansi -Wcheck -Wall -Wpointer-arith -wd981,1599")
  option(EXTRA_WARNINGS
    "Enable extra Intel Compiler warnings and remarks" OFF)
  if(EXTRA_WARNINGS)
    # Enable extra compiler warnings for extra checking
    set (CMAKE_CXX_FLAGS_WARN "${CMAKE_CXX_FLAGS_WARN} -w2 -Weffc++ -wd2012,2015")
  else()
    # 810 - conversion to float
    # 383 - value copied to temporary, reference to temporary used
    # 1418 - external function definition with no prior declaration
    set (CMAKE_CXX_FLAGS_WARN "${CMAKE_CXX_FLAGS_WARN} -wd383,810,1418")
  endif()
  add_definitions (-D_BSD_SOURCE)
  # Set some linker flags
  if(CMAKE_SYSTEM_NAME MATCHES Linux)
    set(CMAKE_SHARED_LINKER_FLAGS
      "-lc ${CMAKE_SHARED_LINKER_FLAGS}")
    set(CMAKE_MODULE_LINKER_FLAGS
      "-lc ${CMAKE_MODULE_LINKER_FLAGS}")
    set (CMAKE_EXE_LINKER_FLAGS
      "-lc ${CMAKE_EXE_LINKER_FLAGS}")
  endif()

  # No RTTI flag
  check_cxx_compiler_flag(-fno-rtti HAVE_NO_RTTI)
  if(HAVE_NO_RTTI)
    set(NO_RTTI_FLAG "-fno-rtti")
    # RTTI flag
    check_cxx_compiler_flag(-frtti HAVE_RTTI)
    if(HAVE_RTTI)
      set(RTTI_FLAG "-frtti")
    else()
      set(RTTI_FLAG "")
    endif()
  else()
    set(NO_RTTI_FLAG "")
    set(RTTI_FLAG "")
  endif()

  check_cxx_compiler_flag(-fvisibility=hidden HAVE_INTEL_VISIBILITY)
  set(HAVE_INTEL_VISIBILITY ${HAVE_INTEL_VISIBILITY} CACHE BOOL "Intel Compiler support for hidden visibility")
  if(HAVE_INTEL_VISIBILITY)
    add_definitions(-DHAVE_GCC_VISIBILITY)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
    check_cxx_compiler_flag(-fvisibility-inlines-hidden HAVE_INTEL_VISIBILITY_INLINES)
    set(HAVE_INTEL_VISIBILITY_INLINES ${HAVE_INTEL_VISIBILITY_INLINES} CACHE BOOL "Intel Compiler support for -fvisibility-inlines-hidden")
    if(HAVE_INTEL_VISIBILITY_INLINES)
      set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
    endif()
  endif()

  set(CMAKE_C_FLAGS_RELEASE "-O3 -ipo1 -DNDEBUG -DQT_NO_DEBUG_OUTPUT -Wl,-s")
  set(CMAKE_CXX_FLAGS_RELEASE "-O3 -ipo1 -DNDEBUG -DQT_NO_DEBUG_OUTPUT -Wl,-s")

  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO
    "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} ${CMAKE_CXX_FLAGS_WARN}")
  set(CMAKE_CXX_FLAGS_DEBUG   "-g3 -fno-inline ${CMAKE_CXX_FLAGS_WARN}")

  TEST_IF_WE_NEED_FPERMISSIVE(NEED_FPERMISSIVE)
  if(NEED_FPERMISSIVE)
    #OK, adding -fpermissive to the C++ compiler flags
    #Workaround for a problem with Boost.Python and GCC >= 4.3.1
    #Further information: cmake/modules/TestIfWeNeedFPermissive.cmake
    set (CMAKE_CXX_FLAGS   "${CMAKE_CXX_FLAGS} -fpermissive")
  endif()

  # define WITH_SSE2 to enable the SSE2 instruction set.
  # Available on Pentium 4, Athlon 64, and newer CPUs.
  # If SSE2 is enabled, Eigen uses it by default; this can be disabled by
  # definining EIGEN_DONT_VECTORIZE.
  if(CMAKE_SIZEOF_VOID_P EQUAL 8 OR WITH_SSE2)
    message(STATUS "Enabling the SSE2 instruction set")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
  endif()
endif()

set(I18N_LANGUAGE "" CACHE STRING "Build i18n only for selected language")

find_package(Qt4 4.6.0 REQUIRED) # find and setup Qt4 for this project
find_package(OpenGL REQUIRED) # find and setup OpenGL
find_package(Linguist) # find and setup Linguist
if(NOT Linguist_FOUND)
  message(WARNING " Qt4 Linguist not found, please install it if you want Avogadro translations")
endif()

find_package(Eigen3) # find and setup Eigen3 if available
if(NOT EIGEN3_FOUND)
   message(STATUS "Cannot find Eigen3, trying Eigen2")
   find_package(Eigen2 REQUIRED) # Some version is required
else()
# Use Stage10 Eigen3 support
   set (EIGEN2_SUPPORT_STAGE10_FULL_EIGEN2_API TRUE)
endif()

find_package(ZLIB REQUIRED)
find_package(OpenBabel2 REQUIRED) # find and setup OpenBabel

# Check if we are building from a Git clone or a released version
function(git_version dir version_var)
  # Function to figure out the Git short version hash
  if(EXISTS ${dir}/.git)
    execute_process(COMMAND git rev-parse --short HEAD
            WORKING_DIRECTORY ${dir}
            OUTPUT_VARIABLE var)
    string(REGEX REPLACE "\n" "" var "${var}")
    message(STATUS "Git revision found to be ${var}")
    set(${version_var} "${var}" PARENT_SCOPE)
  endif(EXISTS ${dir}/.git)
endfunction()

git_version(${CMAKE_SOURCE_DIR} SCM_REVISION)
message(STATUS "Found Git revision is: ${SCM_REVISION}")
if(SCM_REVISION)
  message(STATUS "Building development version from Git clone.")
else()
  message(STATUS "Building released version.")
endif()

###########################################################
# Python Support: Detect and report all stuff here.       #
# Subdirectories can use: ALL_PYTHON_FOUND                #
###########################################################
option(ENABLE_PYTHON "Enable python support" ON)
if(ENABLE_PYTHON)
  include(PythonDeps)
  if(ALL_PYTHON_FOUND)
    message(STATUS "All python dependencies found - Python support enabled")
  else()
    set(ENABLE_PYTHON FALSE)
    message(WARNING "Not all python dependencies are found - Python support diabled")
  endif()
else()
  message(STATUS "Python support disabled.")
endif()

# Unit testing, mainly useful for developers and so defaults to off
option(ENABLE_TESTS "Enable unit testing" OFF)
if(ENABLE_TESTS)
  set(QT_USE_QTTEST TRUE)
  enable_testing()
  include (CTest)
  message(STATUS "Unit testing enabled, run make test to run them")
endif()

# GLSL support is needed for OpenGL shaders
option(ENABLE_GLSL "Enable GLSL support" OFF)
if(ENABLE_GLSL)
  find_package(GLEW)
  if(GLEW_FOUND)

=== avogadro/src/CMakeLists.txt ===
set(QT_USE_QTOPENGL true)
set(QT_USE_QTNETWORK true)

if(WIN32)
  set(QT_USE_QTMAIN true)
endif()

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/config.h
)

link_directories(${OPENBABEL2_LIBRARY_DIRS})

# Ensure the Avogadro include directory is always first
get_directory_property(tmp_include_dirs INCLUDE_DIRECTORIES)
set_directory_properties(PROPERTIES INCLUDE_DIRECTORIES
  "${libavogadro_BINARY_DIR}/include;${tmp_include_dirs}")
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${OPENBABEL2_INCLUDE_DIR}
  ${EIGEN2_INCLUDE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
)

if(GLEW_FOUND)
  include_directories(${GLEW_INCLUDE_DIR})
endif()

include(${QT_USE_FILE})

option(QtTesting "Enable Qt Testing framework?" OFF)
if(QtTesting)
  find_package(QtTesting REQUIRED)
  include_directories(${QtTesting_INCLUDE_DIRS})
  link_directories(${QtTesting_LIBRARY_DIR})
  add_definitions(-DQTTESTING)
endif()

FILE(GLOB avogadro_SRCS "*.cpp")

# Should we build the update checking code? Currently causes segfaults with Qt
# 4.5.3 on both Arch and Gentoo 64 bit platforms (may be more)
option(ENABLE_UPDATE_CHECKER
  "Should the Avogadro update checking code be compiled?" OFF)
if(ENABLE_UPDATE_CHECKER)
  add_definitions(-DENABLE_UPDATE_CHECKER)
else()
  list(REMOVE_ITEM avogadro_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/updatecheck.cpp")
  list(REMOVE_ITEM avogadro_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/updatedialog.cpp")
endif()

FILE(GLOB projectDelegates_SRCS "projectdelegates/*.cpp")
set(avogadro_SRCS ${avogadro_SRCS} ${projectDelegates_SRCS})

if(WIN32)
  set(avogadro_SRCS ${avogadro_SRCS} windows/avogadro.rc)
endif()

file(GLOB avogadro_RCS "*.qrc")

file(GLOB avogadro_UIS "*.ui")

# designer has some flaws.
qt4_automoc(${avogadro_SRCS})
qt4_add_resources(avogadro_RC_SRCS ${avogadro_RCS})
qt4_wrap_ui(avogadro_UIS_H ${avogadro_UIS})

if(NOT WIN32)
  if(Linguist_FOUND)
    file(GLOB_RECURSE lang_PO  "${Avogadro_SOURCE_DIR}/i18n/avogadro/*.po")
    foreach(po ${lang_PO})
      string(REGEX REPLACE "(.*)/([^.]+)\\.po" "\\1/avogadro-\\2.po" po ${po})
      list(APPEND avogadro_PO ${po})
    endforeach()
    QT4_WRAP_PO(avogadro_QM ${avogadro_PO})
  endif()
else()
  # don't attempt to create QM files on windows -- copy them from a linux build!
  file(GLOB_RECURSE avogadro_QM "${Avogadro_SOURCE_DIR}/avogadro/src/avogadro*.qm")
endif()

# Some relative rpath handling for Linux
if(UNIX AND ENABLE_RPATH AND NOT APPLE)
  # Set a relative rpath on Linux - just testing right now...
  set(CMAKE_INSTALL_RPATH "$ORIGIN/../lib${LIB_SUFFIX}")
endif()

add_executable(avogadro-app WIN32 MACOSX_BUNDLE
  ${avogadro_SRCS}
  ${avogadro_UIS_H}
  ${avogadro_RC_SRCS}
  ${avogadro_QM}
)

set_target_properties(avogadro-app PROPERTIES
  OUTPUT_NAME avogadro
  LABELS avogadro-app)
set_source_files_properties(${avogadro_SRCS}
  PROPERTIES LABELS avogadro)

target_link_libraries(avogadro-app
  ${QT_LIBRARIES}
  ${OPENBABEL2_LIBRARIES}
  avogadro)
if(QtTesting)
  target_link_libraries(avogadro-app QtTesting)
endif()
if(Q_WS_X11)
  target_link_libraries(avogadro-app ${X11_X11_LIB})
endif()

if(ENABLE_PYTHON)
  target_link_libraries(avogadro-app ${Boost_LIBRARIES})
endif()

if(ENABLE_UPDATE_CHECKER)
  target_link_libraries(avogadro-app ${QT_QTNETWORK_LIBRARY})
endif()

if(APPLE)
  set(MACOSX_BUNDLE_INFO_STRING "Avogadro - version ${Avogadro_VERSION_FULL}")
  set(MACOSX_BUNDLE_BUNDLE_VERSION ${Avogadro_VERSION_FULL})
  # Change following line to point to actual icns file in bundle.
  set(MACOSX_BUNDLE_ICON_FILE "avogadro.icns")
  # means bundle is set to be net.sourceforge.Avogadro
  set(MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge")
  set(MACOSX_BUNDLE_BUNDLE_NAME "Avogadro")

  set(CMAKE_INSTALL_DESTINATION_ARGS
      BUNDLE DESTINATION "${CMAKE_BUNDLE_LOCATION}")
  # This also sets the bundle name correctly
  set_target_properties(avogadro-app
    PROPERTIES OUTPUT_NAME "${CMAKE_BUNDLE_NAME}")

  # Use relative paths for the executable to link to its libraries
  set_target_properties(avogadro-app PROPERTIES
    CMAKE_INSTALL_NAME_DIR "@executable_path/../lib")

  set(MACOSX_SRC_DIR ${avogadro_SOURCE_DIR}/src/mac)

  # Overload the Info.plist default
  set(CMAKE_MODULE_PATH ${avogadro_SOURCE_DIR}/src/mac ${CMAKE_MODULE_PATH})

  # Do not install the bundle into the prefix - just everything else
  set(Avogadro_INSTALL_DESTINATIONS_ARGS
    BUNDLE DESTINATION "${CMAKE_BUNDLE_LOCATION}")

  install(FILES "mac/avogadro.icns" DESTINATION Resources)
  install(FILES "mac/AvogadroDocument.icns" DESTINATION Resources)

  # install .nib file
  set(QT_COCOA_NIB /Library/Frameworks/QtGui.framework/Versions/Current/Resources/qt_menu.nib)
  if(EXISTS ${QT_COCOA_NIB})
    install(DIRECTORY ${QT_COCOA_NIB}
      DESTINATION Resources
      USE_SOURCE_PERMISSIONS)
  endif()

# Install a .lproj directory for each translation
# We're assuming that there will never be an libavogadro translation
#  without a corresponding avogadro one.
# (Fairly safe assumption)

# This regex gives us translations with just two characters
#  (e.g., avogadro_fr.ts)
  string(REGEX MATCHALL "-[a-z]+\\.po" langresult "${avogadro_PO}")
  string(REGEX REPLACE "-([^.]+)\\.po" "\\1" languages "${langresult}")
# This one gives us languages for country codes (e.g., avogadro_zh_CN.ts)
  string(REGEX MATCHALL "-[a-z]+_[A-Z]+\\.po" langresult "${avogadro_PO}")
  string(REGEX REPLACE "-([^_]+_[^.]+)\\.po" "\\1" fulllangs "${langresult}")
  set (LANGUAGES "${languages};${fulllangs};en;en_US")

  foreach(lang ${LANGUAGES})
    set( MAC_LANG_DIR "${CMAKE_INSTALL_PREFIX}/Resources/${lang}.lproj" )
    install(CODE "EXECUTE_PROCESS(COMMAND
      mkdir ${MAC_LANG_DIR}
      ERROR_QUIET)")
    install(CODE "EXECUTE_PROCESS(COMMAND
      ${MACOSX_SRC_DIR}/lang.sh ${MACOSX_SRC_DIR} ${MAC_LANG_DIR} ${Avogadro_VERSION_FULL} ${lang}
      OUTPUT_QUIET)")
  endforeach()
endif()

install(TARGETS avogadro-app RUNTIME DESTINATION ${BIN_INSTALL_DIR}
  ${Avogadro_INSTALL_DESTINATIONS_ARGS})

install(FILES ${avogadro_QM} DESTINATION ${I18N_INSTALL_DIR})

if(APPLE AND ENABLE_AVO_PACKAGE)
  set(OSX_MAKE_STANDALONE_BUNDLE_CMAKE_SCRIPT
    "${CMAKE_BINARY_DIR}/Avogadro_OSX_MakeStandAloneBundle.cmake")
  set(OSX_MAKE_STANDALONE_BUNDLE_BASH_SCRIPT
    "${CMAKE_BINARY_DIR}/Avogadro_OSX_MakeStandAloneBundle.sh")
  # Configure the cmake file and the shell script
  configure_file("${MACOSX_SRC_DIR}/CompleteBundle.cmake.in"
    "${OSX_MAKE_STANDALONE_BUNDLE_CMAKE_SCRIPT}" @ONLY IMMEDIATE)
  configure_file("${MACOSX_SRC_DIR}/CreateBundle.sh.in"
    "${OSX_MAKE_STANDALONE_BUNDLE_BASH_SCRIPT}" @ONLY IMMEDIATE)
  install(SCRIPT "${OSX_MAKE_STANDALONE_BUNDLE_CMAKE_SCRIPT}")
endif()

# Install a .desktop file and icon for users of XDG-aware OSes
if(XDG_APPS_INSTALL_DIR AND XDG_ICON_INSTALL_DIR)
  install(FILES "avogadro.desktop" DESTINATION "${XDG_APPS_INSTALL_DIR}")
  install(FILES "icons/avogadro-icon.png" DESTINATION "${XDG_ICON_INSTALL_DIR}")
endif()

=== libavogadro/src/CMakeLists.txt ===
set(QT_USE_QTOPENGL true)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/config.h)

include(${QT_USE_FILE})

# Ensure the Avogadro include directory is always first
get_directory_property(tmp_include_dirs INCLUDE_DIRECTORIES)
set_directory_properties(PROPERTIES INCLUDE_DIRECTORIES
  "${libavogadro_BINARY_DIR}/include;${tmp_include_dirs}")
include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${EIGEN2_INCLUDE_DIR}
  ${OPENBABEL2_INCLUDE_DIR}
)

# I think this is necessary now in order to tell the linker where openbabel is
link_directories(${OPENBABEL2_LIBRARY_DIRS})

# Only headers with exported symbols should actually be installed
set(libavogadro_HDRS
  animation.h
  atom.h
  bond.h
  camera.h
  color3f.h
  colorbutton.h
  color.h
  cube.h
  dockextension.h
  dockwidget.h
  elementtranslator.h
  engine.h
  extension.h
  fragment.h
  glhit.h
  global.h
  glwidget.h
  idlist.h
  meshgenerator.h
  mesh.h
  moleculefile.h
  molecule.h
  navigate.h
  neighborlist.h
  obeigenconv.h
  painterdevice.h
  painter.h
  periodictableview.h
  plotaxis.h
  plotobject.h
  plotpoint.h
  plotwidget.h
  plugin.h
  pluginmanager.h
  primitive.h
  primitivelist.h
  protein.h
  residue.h
  textmatrixeditor.h
  toolgroup.h
  tool.h
  undosequence.h
  zmatrix.h
)

set(libavogadro_SRCS
  animation.cpp
  atom.cpp
  bond.cpp
  camera.cpp
  color.cpp
  colorbutton.cpp
  cube.cpp
  cylinder_p.cpp
  dockextension.cpp
  dockwidget.cpp
  elementdetail_p.cpp
  elementitem_p.cpp
  elementtranslator.cpp
  engine.cpp
  extension.cpp
  fragment.cpp
  glhit.cpp
  global.cpp
  glpainter_p.cpp
  glwidget.cpp
  idlist.cpp
  mesh.cpp
  meshgenerator.cpp
  molecule.cpp
  moleculefile.cpp
  navigate.cpp
  neighborlist.cpp
  painter.cpp
  periodictablescene_p.cpp
  periodictableview.cpp
  plotaxis.cpp
  plotobject.cpp
  plotpoint.cpp
  plotwidget.cpp
  plugin.cpp
  pluginmanager.cpp
  primitive.cpp
  primitivelist.cpp
  protein.cpp
  readfilethread_p.cpp
  residue.cpp
  sphere_p.cpp
  textrenderer_p.cpp
  textmatrixeditor.cpp
  tool.cpp
  toolgroup.cpp
  undosequence.cpp
  zmatrix.cpp
)

set(libavogadro_MOC_HDRS
  animation.h
  atom.h
  bond.h
  color.h
  colorbutton.h
  cube.h
  dockextension.h
  dockwidget.h
  elementdetail_p.h
  elementtranslator.h
  engine.h
  extension.h
  fragment.h
  glwidget.h
  mesh.h
  meshgenerator.h
  molecule.h
  moleculefile.h
  periodictablescene_p.h
  periodictableview.h
  plotwidget.h
  plugin.h
  pluginmanager.h
  primitive.h
  protein.h
  readfilethread_p.h
  residue.h
  textmatrixeditor.h
  tool.h
  toolgroup.h
  zmatrix.h
)

set(AVO_LINK_LIBRARIES
  ${OPENBABEL2_LIBRARIES}
  ${QT_LIBRARIES}
  ${OPENGL_LIBRARIES}
)

if(GLEW_FOUND)
  include_directories(${GLEW_INCLUDE_DIR})
  list(APPEND AVO_LINK_LIBRARIES ${GLEW_LIBRARY})
endif()

# Library translations
if(NOT WIN32)
  if(Linguist_FOUND)
    file(GLOB_RECURSE lang_PO "${Avogadro_SOURCE_DIR}/i18n/libavogadro/*.po")
    foreach(po ${lang_PO})
      string(REGEX REPLACE "(.*)/([^.]+)\\.po" "\\1/libavogadro-\\2.po" po ${po})
      list(APPEND libavogadro_PO ${po})
    endforeach()
    QT4_WRAP_PO(libavogadro_QM ${libavogadro_PO})
  endif()
else()
  # don't attempt to create QM files on windows -- copy them from a linux build!
  file(GLOB_RECURSE libavogadro_QM
    "${Avogadro_SOURCE_DIR}/libavogadro/src/libavogadro*.qm")
endif()

# you have to add link_directories before you add the target
if(ENABLE_PYTHON AND ALL_PYTHON_FOUND)
  message(STATUS "Setting new boost python libraries")
  include_directories(
    ${Boost_INCLUDE_DIRS}
    ${PYTHON_INCLUDE_PATH})
  qt4_add_resources(pythontool_RC_SRCS pythontool.qrc)
  list(APPEND AVO_LINK_LIBRARIES ${PYTHON_LIBRARIES} ${Boost_LIBRARIES})
  list(APPEND libavogadro_HDRS
    pythoninterpreter.h
    pythonscript.h
    pythonerror.h)
  list(APPEND libavogadro_MOC_HDRS
    pythonengine_p.h
    pythonerror.h
    pythonextension_p.h
    pythontool_p.h)
  list(APPEND libavogadro_SRCS
    pythoninterpreter.cpp
    pythonscript.cpp
    pythonerror.cpp
    pythontool_p.cpp
    pythonengine_p.cpp
    pythonextension_p.cpp)
endif()

qt4_wrap_cpp(libavogadro_MOC ${libavogadro_MOC_HDRS}
  OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED)

# Set up the include directory and symlink/copy all headers to it.
# Note: Windows lacks symlinks and so the files must be copied.
make_directory("${libavogadro_BINARY_DIR}/include/avogadro")
if(UNIX)
  set(header_cmd "create_symlink")
else()
  set(header_cmd "copy_if_different")
endif()
foreach(headerFile ${libavogadro_HDRS})
  set(from "${CMAKE_CURRENT_SOURCE_DIR}/${headerFile}")
  set(to   "${libavogadro_BINARY_DIR}/include/avogadro/${headerFile}")
  execute_process(COMMAND ${CMAKE_COMMAND} -E ${header_cmd} "${from}" "${to}")
endforeach()

add_library(avogadro SHARED
  ${libavogadro_SRCS}
  ${libavogadro_MOC}
  ${libavogadro_QM}
  ${pythontool_RC_SRCS})
set_target_properties(avogadro PROPERTIES
  VERSION ${Avogadro_VERSION_FULL}
  LINK_INTERFACE_LIBRARIES ""
  SOVERSION ${AVO_SOVERSION}
  LABELS avogadro)
install(FILES ${libavogadro_HDRS}
  DESTINATION "${INCLUDE_INSTALL_DIR}/avogadro")
install(TARGETS avogadro DESTINATION ${LIB_INSTALL_DIR} EXPORT AvogadroTargets)

# Add the engiens, tools and extensions directories
add_subdirectory(engines)
add_subdirectory(tools)
add_subdirectory(extensions)
add_subdirectory(colors)

set(static_plugin_instantiation "#include <QtCore/QCoreApplication>\n")
foreach(plugin ${plugins_built_static})
  set(static_plugin_instantiation "${static_plugin_instantiation}
Q_IMPORT_PLUGIN(${plugin})")
endforeach()
set(static_plugin_instantiation "${static_plugin_instantiation}
void initAvogadroResources()
{
")
foreach(plugin ${plugins_rcc_static})
  set(static_plugin_instantiation "${static_plugin_instantiation}
Q_INIT_RESOURCE(${plugin});")
endforeach()
set(static_plugin_instantiation "${static_plugin_instantiation}
}
")
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/staticplugins.cpp.in
  "${static_plugin_instantiation}\n")
configure_file(${CMAKE_CURRENT_BINARY_DIR}/staticplugins.cpp.in
  ${CMAKE_CURRENT_BINARY_DIR}/staticplugins.cpp)

target_link_libraries(avogadro ${AVO_LINK_LIBRARIES} ${plugins_built_static})
message(STATUS "Linking in static plugins: ${plugins_built_static}")
# Add the boost python module if the boost::python was found
if(ENABLE_PYTHON AND ALL_PYTHON_FOUND)
  add_subdirectory(python)
endif()

install(FILES ${libavogadro_QM} DESTINATION ${I18N_INSTALL_DIR})

if(NOT APPLE)
  install(EXPORT AvogadroTargets DESTINATION ${LIB_INSTALL_DIR}/avogadro)
endif()

=== libavogadro/tests/CMakeLists.txt ===
set(QT_USE_QTOPENGL true)

include(${QT_USE_FILE})

# define TESTDATADIR for tests that need input files
cmake_policy(SET CMP0005 NEW) # needed for line below (escapes value)
add_definitions( -DTESTDATADIR="${CMAKE_SOURCE_DIR}/testfiles/" )

# Ensure the Avogadro include directory is always first
get_directory_property(tmp_include_dirs INCLUDE_DIRECTORIES)
set_directory_properties(PROPERTIES INCLUDE_DIRECTORIES
  "${libavogadro_BINARY_DIR}/include;${tmp_include_dirs}")
include_directories(
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${EIGEN2_INCLUDE_DIR}
  ${OPENBABEL2_INCLUDE_DIR}
  ${BOOST_PYTHON_INCLUDES}
  ${PYTHON_INCLUDE_PATH}
)

link_directories(
  ${libavogadro_BINARY_DIR}/src
  ${OPENBABEL2_LIBRARY_DIRS}
)

# Disabled hydrogenscommand test for now - needs some work. Moc issues here.
# The commands should not just be included, they either need linking to
# or building. As plugin code is not part of the library it may require a
# different testing strategy.
set(tests
  drawcommand
#  hydrogenscommand
  molecule
  moleculefile
  neighborlist
)

foreach (test ${tests})
  message(STATUS "Test:  ${test}")
  set(test_SRCS ${test}test.cpp)
  set(test_MOC_CPPS ${test}test.cpp)
  QT4_WRAP_CPP(test_MOC_SRCS ${test_MOC_CPPS})
  ADD_CUSTOM_TARGET(${test}testmoc ALL DEPENDS ${test_MOC_SRCS})
  add_executable(${test}test ${test_SRCS})
  add_dependencies(${test}test ${test}testmoc)
  target_link_libraries(${test}test
    ${OPENBABEL2_LIBRARIES}
    ${QT_LIBRARIES}
    ${QT_QTTEST_LIBRARY}
    avogadro)
  add_test(${test}Test ${CMAKE_BINARY_DIR}/bin/${test}test)
  set_property(SOURCE ${test_SRCS} PROPERTY LABELS avogadro)
  set_property(TARGET ${test}test PROPERTY LABELS avogadro)
  set_property(TEST ${test}Test PROPERTY LABELS avogadro)
endforeach ()

# More complicated tests (i.e., with linking)
#message(STATUS "Test:  primitivemodeltest")
#  set(primitivemodeltest_SRCS primitivemodeltest.cpp modeltest.cpp)
#  set(primitivemodeltest_MOC_CPPS primitivemodeltest.cpp)
#  QT4_WRAP_CPP(primitivemodeltest_MOC_SRCS ${primitivemodeltest_MOC_CPPS})
#  ADD_CUSTOM_TARGET(primitivemodeltestmoc ALL DEPENDS 
#                                          ${primitivemodeltest_MOC_SRCS})
#  add_executable(primitivemodeltest ${primitivemodeltest_SRCS})
#  add_dependencies(primitivemodeltest primitivemodeltestmoc)
#  target_link_libraries(primitivemodeltest
#    ${OPENBABEL2_LIBRARIES}
#    ${QT_LIBRARIES}
#    ${QT_QTTEST_LIBRARY}
#    avogadro)
#add_test(primitivemodelTest ${CMAKE_BINARY_DIR}/bin/primitivemodeltest)

set(benches
  molecule
)

foreach (bench ${benches})
  message(STATUS "Benchmark:  ${bench}")
  set(bench_SRCS ${bench}bench.cpp)
  qt4_wrap_cpp(bench_MOC_SRCS ${bench_SRCS})
  add_custom_target(${bench}benchmoc ALL DEPENDS
    ${bench_MOC_SRCS})
  add_executable(${bench}bench ${bench_SRCS})
  add_dependencies(${bench}bench ${bench}benchmoc)
  target_link_libraries(${bench}bench
    ${OPENBABEL2_LIBRARIES}
    ${QT_LIBRARIES}
    ${QT_QTTEST_LIBRARY}
    avogadro)
  add_test(${bench}Bench ${CMAKE_BINARY_DIR}/bin/${bench}bench)
  set_property(SOURCE ${bench_SRCS} PROPERTY LABELS avogadro)
  set_property(TARGET ${bench}bench PROPERTY LABELS avogadro)
  set_property(TEST ${bench}Bench PROPERTY LABELS avogadro)
endforeach (bench ${benches})

=== libavogadro/examples/c++/CMakeLists.txt ===
######################################################################
# Example CMake project building a 3rd party extension against 
# installed Avogadro library.  
# See http://avogadro.openmolecules.net/ for more information.
######################################################################

# Project name - plugin name or something meaningful
project(TemplateExtension)

# Minimum version of CMake that can be used
cmake_minimum_required(VERSION 2.6)

# Find the Avogadro library if it is installed
find_package(Avogadro REQUIRED)
 
set(QT_MIN_VERSION "4.5.0")
find_package(Qt4 REQUIRED)

# Activate this line if you need direct use of OpenBabel
#find_package(OpenBabel2 REQUIRED)

# Set up the build environment
include(${Avogadro_USE_FILE})
include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${OPENBABEL2_INCLUDE_DIR}
)
link_directories(${OPENBABEL2_LIBRARY_DIRS})

# Build your plugin using the default options
set (templateextension_SRCS templateextension.cpp)

avogadro_plugin(templateextension "${templateextension_SRCS}")

=== libavogadro/src/extensions/CMakeLists.txt ===
ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_SHARED)

set(DESTINATION_DIR ${Avogadro_PLUGIN_INSTALL_DIR}/extensions)

include_directories(${CMAKE_CURRENT_BINARY_DIR}
  "${CMAKE_CURRENT_SOURCE_DIR}/gl2ps"
)

set(LINK_LIBS avogadro)
set(PLUGIN_LABEL extensions)
set(PLUGIN_TARGET extensions)
add_custom_target(extensions COMMENT "Meta target to build all Avogadro extensions.")

### Template extension - template for extensions
#avogadro_plugin(templateextension templateextension.cpp)

### Properties
avogadro_plugin_nogl(propextension
  "../tools/skeletontree.cpp;propmodel.cpp;propextension.cpp")

avogadro_plugin_nogl(cartesianextension
  cartesianextension.cpp
  cartesianeditor.ui
  cartesianextension.qrc)

avogadro_plugin_nogl(molecularpropextension
  molecularpropextension.cpp
  molecularpropdialog.ui)
target_link_libraries(molecularpropextension ${QT_QTNETWORK_LIBRARY})

### Molecular Mechanics force fields
set(forcefieldextension_SRCS forcefieldextension.cpp forcefielddialog.cpp
  constraintsdialog.cpp constraintsmodel.cpp conformersearchdialog.cpp)
avogadro_plugin_nogl(forcefieldextension
  "${forcefieldextension_SRCS}"
  "forcefielddialog.ui;constraintsdialog.ui;conformersearchdialog.ui")
if(${CMAKE_CXX_COMPILER_ID} MATCHES Intel AND UNIX)
  set_target_properties(forcefieldextension PROPERTIES COMPILE_FLAGS "-fvisibility=default")
endif()

### hydrogens
avogadro_plugin_nogl(hydrogensextension hydrogensextension.cpp)

### invertchirality
avogadro_plugin_nogl(invertchiralextension invertchiralextension.cpp)

### Selections
avogadro_plugin_nogl(selectextension selectextension.cpp)

### insert fragment
avogadro_plugin_nogl(insertfragmentextension
  "insertfragmentextension.cpp;insertfragmentdialog.cpp;insertcommand.cpp;sortfiltertreeproxymodel.cpp"
  insertfragmentdialog.ui)

### insert peptide (builder)
avogadro_plugin_nogl(insertpeptideextension
  "insertpeptideextension.cpp;insertcommand.cpp"
  insertpeptidedialog.ui)

### insert dna (builder)
avogadro_plugin_nogl(insertdnaextension
  "insertdnaextension.cpp;insertcommand.cpp"
  insertdnadialog.ui)

### h->methyl
avogadro_plugin_nogl(h2methylextension h2methylextension.cpp)

if(ENABLE_PYTHON AND ALL_PYTHON_FOUND)
  ### python terminal
  message(STATUS "Enabled python terminal")
  avogadro_plugin_nogl(pythonterminal
    "pythonterminal.cpp;highlighter.cpp"
    pythonterminalwidget.ui)
  target_link_libraries(pythonterminal ${PYTHON_LIBRARIES})

  file(GLOB python_SCRIPTS "python/*.py")
  install(FILES ${python_SCRIPTS} DESTINATION share/libavogadro/extensionScripts)
endif()

### Animation
set(animationextension_SRCS animationextension.cpp animationdialog.cpp
  povpainter.cpp trajvideomaker.cpp)
avogadro_plugin_nogl(animationextension
  "${animationextension_SRCS}"
  animationdialog.ui
  animationextension.qrc)

### POV-Ray extension
avogadro_plugin_nogl(povrayextension
  "povrayextension.cpp;povpainter.cpp;povraydialog.cpp"
  povraydialog.ui)

### File import extension
avogadro_plugin_nogl(fileimportextension fileimportextension.cpp fileimportdialog.ui)

### Shader extension
if(GLEW_FOUND)
  avogadro_plugin(shaderextension
    shaderextension.cpp
    shaderdialog.ui)
  target_link_libraries(shaderextension ${GLEW_LIBRARY})
  file(GLOB shader_VERT "shaders/*.vert")
  file(GLOB shader_FRAG "shaders/*.frag")
  file(GLOB shader_PARAMS "shaders/*.params")
  install(FILES ${shader_VERT} ${shader_FRAG} ${shader_PARAMS}
    DESTINATION share/libavogadro/shaders)
endif()

### super cells
avogadro_plugin_nogl(supercellextension
  "supercellextension.cpp;supercelldialog.cpp"
  supercelldialog.ui)

# Network fetch
avogadro_plugin_nogl(networkfetchextension networkfetchextension.cpp)
target_link_libraries(networkfetchextension ${QT_QTNETWORK_LIBRARY})

# GL2PS
avogadro_plugin(gl2psextension
  "gl2psextension.cpp;gl2ps/gl2ps.c")

# Subdirs
add_subdirectory(crystallography)
add_subdirectory(spectra)
add_subdirectory(surfaces)
add_subdirectory(swcntbuilder)
add_subdirectory(qtaim)
add_subdirectory(quantuminput)

=== libavogadro/src/python/CMakeLists.txt ===
include_directories(
  ${libavogadro_SOURCE_DIR}/include
  ${CMAKE_CURRENT_BINARY_DIR}
  ${OPENBABEL2_INCLUDE_DIR}
  ${BOOST_PYTHON_INCLUDES}
  ${PYTHON_INCLUDE_PATH}
  ${NUMPY_INCLUDE_DIR}
  ${SIP_INCLUDE_DIR}
)

# use all cpp files in this directory
file(GLOB wrapper_SRCS "*.cpp")

qt4_automoc(moleculelist.cpp)

add_library(python-module MODULE ${wrapper_SRCS})
set_target_properties(python-module PROPERTIES OUTPUT_NAME Avogadro)
set_target_properties(python-module PROPERTIES PREFIX "")
if (WIN32)
  set_target_properties(python-module PROPERTIES SUFFIX ".pyd")
  target_link_libraries(python-module avogadro ${PYTHON_LIBRARIES})
else()
  target_link_libraries(python-module stdc++ avogadro
    ${QT_LIBRARIES} ${PYTHON_LIBRARIES} ${Boost_LIBRARIES})
endif()

# Let's try to use this instead:
EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} -c
    "from sys import stdout; from distutils import sysconfig; stdout.write(sysconfig.get_python_lib(1))"
    OUTPUT_VARIABLE PYTHON_LIB_PATH)

message(STATUS "Python site-packages directory: ${PYTHON_LIB_PATH}")

option(INSTALL_PYTHON_MODULE 
  "Install the avogadro python module for the system wide python installation."
  ON)
if (INSTALL_PYTHON_MODULE)
  install(TARGETS python-module DESTINATION ${PYTHON_LIB_PATH})
endif()

=== libavogadro/src/tools/CMakeLists.txt ===
include(${QT_USE_FILE})

add_definitions(${QT_DEFINITIONS})
add_definitions(-DQT_PLUGIN)
add_definitions(-DQT_SHARED)

set(DESTINATION_DIR ${Avogadro_PLUGIN_INSTALL_DIR}/tools)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(LINK_LIBS avogadro)
set(PLUGIN_LABEL tools)
set(PLUGIN_TARGET tools)
add_custom_target(tools COMMENT "Meta target to build all Avogadro tools.")

### drawtool
set(drawtool_SRCS
  drawtool.cpp
  drawcommand.cpp)
avogadro_plugin(drawtool
  "${drawtool_SRCS}"
  drawtool.qrc)

option(ENABLE_ZMATRIX_TOOL "Enable the z-matrix tool (experimental)" OFF)
if(ENABLE_ZMATRIX_TOOL)
  ### zmatrixtool
  set(zmatrixtool_SRCS zmatrixtool.cpp zmatrixdialog.cpp zmatrixmodel.cpp)
  avogadro_plugin(zmatrixtool
    "${zmatrixtool_SRCS}"
    zmatrixdialog.ui;zmatrixtool.qrc)
endif(ENABLE_ZMATRIX_TOOL)

### bondcentrictool
set(bondcentrictool_SRCS bondcentrictool.cpp skeletontree.cpp)
avogadro_plugin(bondcentrictool
  "${bondcentrictool_SRCS}"
  bondcentrictool.qrc)

### clickmeasuretool
avogadro_plugin(clickmeasuretool clickmeasuretool.cpp clickmeasuretool.qrc)

### selectrotatetool
avogadro_plugin(selectrotatetool selectrotatetool.cpp selectrotatetool.qrc)

### autoopttool
avogadro_plugin(autoopttool autoopttool.cpp autoopttool.qrc)
if(${CMAKE_CXX_COMPILER_ID} MATCHES Intel AND UNIX)
  set_target_properties(autoopttool PROPERTIES COMPILE_FLAGS "-fvisibility=default")
endif()

### navigatetool
avogadro_plugin(navigatetool
  "navigatetool.cpp;eyecandy.cpp" "navigatesettingswidget.ui;navigatetool.qrc")

### manipulatetool
avogadro_plugin(manipulatetool
 "manipulatetool.cpp;eyecandy.cpp;moveatomcommand.cpp" "manipulatesettingswidget.ui;manipulatetool.qrc")

### autorotatetool
avogadro_plugin(autorotatetool autorotatetool.cpp autorotatetool.qrc)

### aligntool
avogadro_plugin(aligntool aligntool.cpp aligntool.qrc)

if(ALL_PYTHON_FOUND)
  file(GLOB python_SCRIPTS "python/*.py")
  install(FILES ${python_SCRIPTS} DESTINATION share/libavogadro/toolScripts)
endif()

=== libavogadro/examples/thirdPartyExtensions/01-HelloWorld/CMakeLists.txt ===
# Hello World Avogadro extension.
# See http://avogadro.openmolecules.net/ for more information.

# Project name
project(HelloWorldExtension)

# Minimum version of CMake that can be used
cmake_minimum_required(VERSION 2.6)

# Set up Qt
set(QT_MIN_VERSION "4.5.0")
find_package(Qt4 REQUIRED)

# Set up Avogadro
find_package(Avogadro REQUIRED)
include(${Avogadro_USE_FILE})

# Specify include directories
include_directories(
  # Needed to include Qt moc'd headers
  ${CMAKE_CURRENT_BINARY_DIR}
)

# Create a list of all source files
set( helloworldextension_SRCS
     helloworldextension.cpp
     helloworlddialog.cpp
)

# Create a list of all ui files
set( helloworldextension_UIS
     helloworlddialog.ui
)

# Create the extension target helloworldextension
avogadro_plugin(helloworldextension "${helloworldextension_SRCS}" "${helloworldextension_UIS}")

=== libavogadro/examples/thirdPartyExtensions/02-DynamicDisplay/CMakeLists.txt ===
# Dynamic Display Avogadro extension.
# See http://avogadro.openmolecules.net/ for more information.

# Project name
project(DynamicDisplayExtension)

# Minimum version of CMake that can be used
cmake_minimum_required(VERSION 2.6)

set(QT_MIN_VERSION "4.5.0")
find_package(Qt4 REQUIRED)
find_package(Avogadro REQUIRED)
include(${Avogadro_USE_FILE})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set( dynamicdisplayextension_SRCS
     dynamicdisplayextension.cpp
     dynamicdisplaydialog.cpp
)

set( dynamicdisplayextension_UIS
     dynamicdisplaydialog.ui
)

avogadro_plugin( dynamicdisplayextension
                 "${dynamicdisplayextension_SRCS}"
		 "${dynamicdisplayextension_UIS}")

=== libavogadro/examples/thirdPartyExtensions/03-ViewPlane/CMakeLists.txt ===
# Hello World Avogadro extension.
# See http://avogadro.openmolecules.net/ for more information.

# Project name
project(ViewPlaneExtension)

# Minimum version of CMake that can be used
cmake_minimum_required(VERSION 2.6)

# Set up Qt
set(QT_MIN_VERSION "4.5.0")
find_package(Qt4 REQUIRED)

# Set up Avogadro
find_package(Avogadro REQUIRED)
include(${Avogadro_USE_FILE})

# Specify include directories
include_directories(
  # Needed to include Qt moc'd headers
  ${CMAKE_CURRENT_BINARY_DIR}
)

# Create a list of all source files
set( viewplaneextension_SRCS
     viewplaneextension.cpp
)

# Create the extension target viewplaneextension
avogadro_plugin(viewplaneextension "${viewplaneextension_SRCS}")

=== libavogadro/examples/thirdPartyExtensions/04-RotateSelection/CMakeLists.txt ===
# Hello World Avogadro extension.
# See http://avogadro.openmolecules.net/ for more information.

# Project name
project(RotateSelectionExtension)

# Minimum version of CMake that can be used
cmake_minimum_required(VERSION 2.6)

# Set up Qt
set(QT_MIN_VERSION "4.5.0")
find_package(Qt4 REQUIRED)

# Set up Avogadro
find_package(Avogadro REQUIRED)
include(${Avogadro_USE_FILE})

# Specify include directories
include_directories(
  # Needed to include Qt moc'd headers
  ${CMAKE_CURRENT_BINARY_DIR}
)

# Create a list of all source files
set( rotateselectionextension_SRCS
     rotateselectionextension.cpp
     rotateselectiondialog.cpp
)

# Create a list of all ui files
set( rotateselectionextension_UIS
     rotateselectiondialog.ui
)

# Create the extension target rotateselectionextension
avogadro_plugin(rotateselectionextension "${rotateselectionextension_SRCS}" "${rotateselectionextension_UIS}")

=== debian/changelog ===
avogadro (1.1.1-0ubuntu7) xenial; urgency=medium

  * Link the python library with openbabel2

 -- Iain Lane <iain@orangesquash.org.uk>  Thu, 12 Nov 2015 12:33:47 +0000

avogadro (1.1.1-0ubuntu6) xenial; urgency=medium

  * No-change rebuild against libglew1.13

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 11 Nov 2015 17:16:22 +0000

avogadro (1.1.1-0ubuntu5) wily; urgency=low

  * cmake QT search no longer automatically loads X11 detection, load
    it manually.

 -- Andy Whitcroft <apw@ubuntu.com>  Mon, 10 Aug 2015 20:49:07 +0100

avogadro (1.1.1-0ubuntu4) wily; urgency=medium

  * No change rebuild for boost1.58/libstdc++6.

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Sun, 02 Aug 2015 12:26:37 +0100

avogadro (1.1.1-0ubuntu3) utopic; urgency=high

  * No change rebuild against boost1.55.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sat, 26 Apr 2014 23:36:06 +0100

avogadro (1.1.1-0ubuntu2) trusty; urgency=medium

  * No-change rebuild against sip 4.15.5.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sat, 22 Mar 2014 15:07:23 +0400

avogadro (1.1.1-0ubuntu1) trusty; urgency=medium

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 12 Feb 2014 11:10:29 +0000

avogadro (1.1.0-4ubuntu2) trusty; urgency=medium

  * No change rebuild against glew 1.10.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 02 Jan 2014 13:20:09 +0000

avogadro (1.1.0-4ubuntu1) trusty; urgency=low

  * Merge from debian, remaining changes
    - Add libpython2.7-dev libboost-python-dev to libavogadro-dev

 -- Rohan Garg <rohangarg@kubuntu.org>  Thu, 28 Nov 2013 17:50:48 +0100

avogadro (1.1.0-4) experimental; urgency=low

  [ Daniel Leidert ]
  * debian/rules (override_dh_auto_configure): Drop setting of
    -DPYTHON_INCLUDE_DIRS and fix the FTBFS too (really closes: #710703).
  * debian/patches/use_python_include_dirs.patch: Reverted to 1.1.0-2.
  * debian/patches/series: Don't use the use_python_include_dirs.patch patch.

 -- Debichem Team <debichem-devel@lists.alioth.debian.org>  Sun, 02 Jun 2013 21:39:03 +0200

avogadro (1.1.0-3) experimental; urgency=low

  [ Daniel Leidert ]
  * debian/control (Vcs-Browser, Vcs-Svn): Fixed vcs-field-not-canonical.
  * debian/rules: Try to fix an FTBFS if several Python versions are installed
    (closes: Bug#710703) and don't FTBFS if there is no multi-arch Python.

 -- Debichem Team <debichem-devel@lists.alioth.debian.org>  Sat, 01 Jun 2013 23:50:49 +0200

avogadro (1.1.0-2) experimental; urgency=low

  [ Daniel Leidert ]
  * debian/rules (CPPFLAGS, LDFLAGS): Added -fPIC to fix FTBFS.
  * debian/patches/use_python_include_dirs.patch: Minor fix to FindSIP.cmake
    to fix FTBFS.

 -- Debichem Team <debichem-devel@lists.alioth.debian.org>  Thu, 30 May 2013 00:09:24 +0200

avogadro (1.1.0-1) experimental; urgency=low

  * New upstream release (LP: #1155529).

  [ Daniel Leidert ]
  * debian/avogadro-data.install: Added crystals directory.
  * debian/control: Added a package for debugging symbols.
    (Vcs-Browser, Vcs-Svn): Fixed location.
  * debian/libavogadro-dev.install: Added pkg-config file.
  * debian/rules: Enable debug package and remove python specific stuff.
  * debian/watch: Catch experimental releases.
  * debian/patches/hurd_ftbfs.patch: Removed (not applicable).
  * debian/patches/nwchem_input_ccsd.patch: Dropped (applied upstream).
  * debian/patches/boost148.patch: Updated.
  * debian/patches/link_to_libgl2ps.patch: Updated.
  * debian/patches/use_python_include_dirs.diff: Renamed to 
    debian/patches/use_python_include_dirs.patch, updated and enabled.
  * debian/patches/series: Updated.

 -- Debichem Team <debichem-devel@lists.alioth.debian.org>  Mon, 13 May 2013 23:06:32 +0200

avogadro (1.0.3-6) unstable; urgency=low

  [ Daniel Leidert ]
  * debian/control: Dropped DM-Upload-Allowed field.
    (Uploaders): Removed myself.
    (Standards-Version): Bumped to 3.9.4.
    (Depends): Added non-versioned dependencies to python-numpy, python-qt4
    and python-sip (see #679819).
  * debian/copyright: Added a hint about the text found in some files in the
    testfile directory (closes: #643921). 
  * debian/rules: Removed code to generate versioned dependencies to
    python-numpy, python-qt4 and python-sip. Enable hardening.
  * debian/watch: Minor update to catch bzip2 compressed tarballs and ignore
    experimental releases.
  * debian/patches/use_python_include_dirs.diff: Added based on the patch by
    Ubuntu.

  [ Michael Banck ]
  * debian/upstream: Added reference. 

 -- Debichem Team <debichem-devel@lists.alioth.debian.org>  Sun, 12 May 2013 21:30:52 +0200

avogadro (1.0.3-5ubuntu10) trusty; urgency=low

  * No change rebuild for Boost 1.54 transition.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Tue, 22 Oct 2013 18:08:37 +0100

avogadro (1.0.3-5ubuntu9) saucy; urgency=low

  * Do the same with libboost-python-dev 

 -- Philip Muškovac <yofel@kubuntu.org>  Sat, 17 Aug 2013 16:57:02 +0200

avogadro (1.0.3-5ubuntu8) saucy; urgency=low

  * Add dependency on libpython2.7-dev to libavogadro-dev as cmake expects it
    to be there

 -- Philip Muškovac <yofel@kubuntu.org>  Sat, 17 Aug 2013 15:35:14 +0200

avogadro (1.0.3-5ubuntu7) saucy; urgency=low

  * Make avogadro look for python-py27 boost library, fixing FTBFS.
  * Force using python2.7 via Python_ADDITIONAL_VERSIONS

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 09 Aug 2013 13:13:44 +0100

avogadro (1.0.3-5ubuntu6) saucy; urgency=low

  * Rebuild against sip-api-10

 -- Scott Kitterman <scott@kitterman.com>  Thu, 20 Jun 2013 11:16:36 -0400

avogadro (1.0.3-5ubuntu5) saucy; urgency=low

  * No change rebuild for Boost 1.53 transition.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 26 Apr 2013 19:18:39 +0100

avogadro (1.0.3-5ubuntu4) raring; urgency=low

  * Add support for multiarch python:
    - add use_python_include_dirs.diff to use PYTHON_INCLUDE_DIRS
      instead of PYTHON_INCLUDE_PATH and drop shipped FindPythonLibs.cmake


=== debian/control ===
Source: avogadro
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: cmake (>> 2.6.0),
               debhelper (>> 7.0.50~),
               libboost-python-dev,
               libeigen2-dev (>> 2.0~beta6),
               libgl2ps-dev,
               libglew-dev,
               libopenbabel-dev (>> 2.2.0),
               libqt4-dev (>> 4.5.0),
               libqt4-opengl-dev,
               pkg-config,
               python (>> 2.6.6-3~),
               python-dev,
               python-numpy (>> 1:1.4.1-4~),
               python-sip-dev,
               qt4-dev-tools,
               zlib1g-dev
Standards-Version: 3.9.4
X-Python-Version: current
Homepage: http://avogadro.sourceforge.net/
Vcs-Browser: http://anonscm.debian.org/viewvc/debichem/experimental/avogadro/
Vcs-Svn: svn://anonscm.debian.org/debichem/experimental/avogadro/

Package: avogadro
Architecture: any
Depends: libavogadro1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: avogadro-data (>= 1.0.0-2)
Description: Molecular Graphics and Modelling System
 Avogadro is a molecular graphics and modelling system targeted at molecules
 and biomolecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 Features include:
  * Molecular modeller with automatic force-field based geometry optimization
  * Molecular Mechanics including constraints and conformer searches
  * Visualization of molecular orbitals and general isosurfaces
  * Visualization of vibrations and plotting of vibrational spectra
  * Support for crystallographic unit cells
  * Input generation for the Gaussian, GAMESS and MOLPRO quantum chemistry
    packages
  * Flexible plugin architecture and Python scripting
 .
 File formats Avogadro can read include PDB, XYZ, CML, CIF, Molden, as well as
 Gaussian, GAMESS and MOLPRO output.

Package: avogadro-data
Architecture: all
Depends: ${misc:Depends}
Breaks: avogadro (<< 1.0.0-2), libavogadro0 (<< 1.0.0-2)
Replaces: avogadro (<< 1.0.0-2), libavogadro0 (<< 1.0.0-2)
Description: Molecular Graphics and Modelling System (Data Files)
 Avogadro is a molecular graphics and modelling system targeted at molecules
 and biomolecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package contains data files like molecular builder fragments or
 OpenGL shaders.

Package: libavogadro1
Conflicts: libavogadro0
Replaces: libavogadro0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: avogadro-data (>= 1.0.0-2), python-avogadro
Description: Molecular Graphics and Modelling System (library)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the shared library.

Package: libavogadro-dev
Architecture: any
Section: libdevel
Priority: extra
Depends: libavogadro1 (= ${binary:Version}),
         libeigen2-dev (>= 2.0~beta6),
         libglew-dev,
         libopenbabel-dev (>= 2.2.0),
         libqt4-dev (>= 4.4.0),
         libpython2.7-dev,
         libboost-python-dev,
         ${misc:Depends}
Description: Molecular Graphics and Modelling System (development files)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the development and header files.

Package: python-avogadro
Architecture: any
Section: python
Priority: extra
XB-Python-Version: ${python:Versions}
Depends: python-numpy,
         python-qt4,
         python-sip,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
         ${sip:Depends}
Replaces: libavogadro0 (<< 0.9.8)
Breaks: libavogadro0 (<< 0.9.8)
Provides: ${python:Provides}
Description: Molecular Graphics and Modelling System (Python module)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the Python module.

Package: avogadro-dbg
Architecture: any
Section: debug
Priority: extra
Depends: avogadro (= ${binary:Version}),
         libavogadro1 (= ${binary:Version}),
         ${misc:Depends}
Description: Molecular Graphics and Modelling System (debugging symbols)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the debugging symbols for the library, the application
 and modules.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) -fPIC
export CFLAGS   := $(CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := $(CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS  := -fPIC $(shell dpkg-buildflags --get LDFLAGS) -Wl,-z,defs -Wl,--as-needed

DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
PYTHON_VERSION     := $(shell pyversions -dv)

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/libpython$(PYTHON_VERSION).so),)
PYTHON_LIBRARY=/usr/lib/$(DEB_HOST_MULTIARCH)/libpython$(PYTHON_VERSION).so
else
PYTHON_LIBRARY=/usr/lib/libpython$(PYTHON_VERSION).so
endif

%:
	dh $@ --with python2 --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DENABLE_GLSL=ON \
	-DENABLE_RPATH=OFF \
	-DENABLE_UPDATE_CHECKER=OFF \
	-DPYTHON_EXECUTABLE=/usr/bin/python$(PYTHON_VERSION) \
	-DPYTHON_LIBRARY=$(PYTHON_LIBRARY) \
	-DPYTHON_INCLUDE_DIR=/usr/include/python$(PYTHON_VERSION)/

override_dh_install:
	dh_install --list-missing

override_dh_clean:
	dh_clean conf.log conf.pri

override_dh_python2:
	dh_python2 -ppython-avogadro
	dh_numpy -ppython-avogadro
	dh_sip

override_dh_strip:
	dh_strip --dbg-package=avogadro-dbg
